/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef date_h
#define date_h

#include <stdio.h> /* need FILE* but can't use futil.h since it uses us */

#ifdef THINK_C
#include <time.h>
#else
#include <sys/time.h>
#endif

#include "cutil.h"

typedef struct date
{ long year;   /* AD */
  long month;  /* 1 - 12 */
  long day;    /* 1 - 31 */
  long hour;   /* 1 - 24 XXX or 0 - 23? */   
  long minute; /* 0 - 59 */
  long second; /* 0 - 59 */
} date;

void    dateFromTime(date* d,time_t secSince1970);
boolean timeFromDate(date* d,time_t* secSince1970);

#define YYYYMMDD_LEN (8L)
char*   dateToYYYYMMDD(date* d);
date*   YYYYMMDDToDate(char* s);

#define YYYYMMDDHHMMSS_LEN (14L)
char*   dateToYYYYMMDDHHMMSS(date* d);
date*   YYYYMMDDHHMMSSToDate(char* s);

void    writeDate(FILE* file,date* d);
void    readDate(FILE* file,date* d);

date*   latestDate(date* d1,date* d2);

boolean eqDate(date* d1,date* d2);

void    dateNow(date* d);

date*   copyDate(date* d);

boolean isValidYYYYMMDDHHMMSSDate(char* word);

#endif date_h
