#include <ctype.h>

#include "panic.h"
#include "waislog.h"
#include "cutil.h"

static dumpOnError = false;

/*----------------------------------------------------------------------*/

void
dumpCoreOnError(boolean dump)
{ dumpOnError = dump;
}

/*----------------------------------------------------------------------*/

void
panic(char* formatString,...)
/* something bad and unexpected has happened, print out a log message 
   and abort the program in such a way that it can be debugged.
 */
{
  va_list ap;			
  char msg[2000];		

  va_start(ap,formatString);	
  vsprintf(msg,formatString,ap);
  waislog(WLOG_HIGH,WLOG_ERROR,msg);
  va_end(ap);			

#ifdef THINK_C
  Debugger();
#endif

  if (dumpOnError)
    abort(); 
  else
    exit(1L);
}


/*----------------------------------------------------------------------*/

