/* WIDE AREA INFORMATION SERVER SOFTWARE	
   No guarantees or restrictions.  See the readme file for the full standard 
   disclaimer.  
   4.14.90	Harry Morris, morris@think.com
*/

#ifndef lint
static char *RCSid = "$Header: /proj/wais/development/CVS/waisserver/ir/ustubs.c,v 1.2 1994/10/08 00:30:05 morris Exp $";
#endif

/* Change log:
 * $Log: ustubs.c,v $
 * Revision 1.2  1994/10/08  00:30:05  morris
 * waisserver version 2.0
 *
 * Revision 1.1.1.1  1994/07/25  20:10:10  ben
 * WAIS 2.0 release
 *
 * Revision 1.4  92/05/06  17:35:13  jonathan
 * Modified some #if's for NeXT and Mach.
 * 
 * Revision 1.3  92/03/06  11:08:49  jonathan
 * fixed incompatible return type error in HP version of getwd.  Thanks to
 * cshotton@oac.hsc.uth.tmc.edu.
 * 
 * Revision 1.2  92/02/12  13:54:29  jonathan
 * Added "$Log" so RCS will put the log message in the header
 * 
 * 
*/

/*----------------------------------------------------------------------*/
/* stubs for silly non-ansi c compilers                                 */
/*----------------------------------------------------------------------*/

#include "ustubs.h"
#include "futil.h" /* for MAX_FILENAME_LEN */
#include "cutil.h" /* for substrcmp and NULL */



/*----------------------------------------------------------------------*/

#ifdef DellUnix
#include <sys/utsname.h>
#endif /* def DellUnix */

#if (defined(__svr4__) || defined(hpux) || defined(SCOUnix))

char*
getwd(char* pathname)
{
  return((char*)getcwd(pathname, MAX_FILENAME_LEN));
}

long 
random(void)
{ 
  return(rand());
}

long 
srandom(unsigned long seed)
{ 
  srand(seed);
  return(0);
}

#ifndef SCOUnix
#ifndef hpux
#include <sys/systeminfo.h>
#endif /* ndef hpux */
#endif /* ndef SCOUnix */

#ifndef hpux
long
gethostname(char* hostname,long len)
{ 
#ifndef SCOUnix
  return(sysinfo(SI_HOSTNAME,hostname,len));
#endif /* ndef SCOUnix */
}
#endif /* ndef hpux */

long
gethostid(void)
{
#ifndef SCOUnix
  /* Here, I'm assuming that the machine's Serial Number probably would not be
     much more than the size of a long;  if it's numerical, I'll just read it
     using atol(), but if not, then I'll just cast those 8 or so chars into a
     long.   -Ben, 10/6/94
   */
  char hostIDStr[257];
  sysinfo(SI_HW_SERIAL,hostIDStr,sizeof(hostIDStr));
  if (isdigit(hostIDStr[0]))
    return (atol(hostIDStr));
  else
    return (*(long *)hostIDStr);    
#else /* ndef SCOUnix */
  return(0);
#endif
}

long 
sigmask(long sig)
{
}

long 
sigblock(long mask)
{
}

long 
sigsetmask(long mask)
{
}

#endif /* def SYSV */

/*----------------------------------------------------------------------*/

#ifndef ANSI_LIKE   /* memmove is an ANSI function not defined by K&R */
#ifndef hpux /* but HP defines it */
void*
memmove(void* str1,void* str2,size_t n)
/* XXX NOTE - on AUX bcopy is not safe for overlapping memory, thus this is
   wrong 
 */
{
#ifdef M_XENIX
  memcpy((char*)str2,(char*)str1,(long)n); /* hope it works! */
#else /* ndef M_XENIX */
  bcopy((char*)str2,(char*)str1,(long)n);
#endif /* ndef M_XENIX */
  return(str1);
}
#endif /* ndef hpux */

#else /* ansi is defined */

#ifdef __GNUC__ /* we are ansi like, are we gcc */

#if !(defined(NeXT) || defined(Mach) || defined(__svr4__) || defined(SCOUnix)) 
       /* and we are not on a next or solaris or SCO! */

void*
memmove(void* str1,void* str2,size_t n)
{
  bcopy((char*)str2,(char*)str1,(long)n);
  return(str1);
}

#endif /* not NeXT or Mach */

#endif /* __GNUC__ */

#endif /* else ndef ANSI_LIKE */

/*----------------------------------------------------------------------*/

#ifndef ANSI_LIKE  

/* atoi is not defined k&r. copied from the book */
long 
atol(char* s)
{
  long i, n, sign;
  for(i=0; s[i]==' ' || s[i]== 'n' || s[i]=='t'; i++)
    ;				/* skip white space */
  sign = 1;
  if (s[i] == '+' || s[i] == '-')
    sign = (s[i++]=='+') ? 1 : -1;
  for (n=0; s[i] >= '0' && s[i] <= '9'; i++)
    n= 10 * n + s[i] - '0';
  return(sign * n);
}

/*----------------------------------------------------------------------*/

char*
strstr(char* src,char* sub)
{
  /* this is a poor implementation until the ANSI version catches on */
  char *ptr;
  for(ptr = src; (long)ptr <= (long)src + strlen(src) - strlen(sub); ptr++){
    if(substrcmp(ptr, sub))
      return(ptr);
  }
  return(NULL);
}

/*----------------------------------------------------------------------*/

int 
remove(char* filename)
{
  return(unlink(filename));
}

/*----------------------------------------------------------------------*/

#endif /* ndef ANSI_LIKE */




