/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef connZ39501988_h 
#define connZ39501988_h 

#include "conn1988Mgr.h"

/*---------------------------------------------------------------------------*/
/* INIT */
/*---------------------------------------------------------------------------*/

appConnStatus z39501988InitReqWrite(appConn* conn,
				    char*    user,    
				    char*    password,
				    char*    clientInfo,
				    any*     userInfo,
				    list*    diags);

appConnStatus z39501988InitRespRead(appConn* conn,  
				    any**    userInfo,
				    list*    diags);

/*---------------------------------------------------------------------------*/
/* SEARCH */
/*---------------------------------------------------------------------------*/

appConnStatus z39501988SearchReqWrite(appConn*    conn,  
				      long        maxHits,
				      long        hitsRequested, 
				      long        rankingScheme, 
				      char*       dbName, 
				      appConnQry* qry,
				      any*        userInfo,
				      list*       diags);

appConnStatus z39501988SearchRespRead(appConn* conn,
				      long*    totalHits, 
				      list*    qryTermsUsed,
				      list*    hits,
				      any**    userInfo,
				      list*    diags);

appConnStatus z39501988NextHeadlinesReqWrite(appConn* conn,
					     long     startingFromHit, 
					     long     hitsRequested,
					     any*     userInfo,
					     list*    diags);

appConnStatus z39501988NextHeadlinesRespRead(appConn* conn,
					     list*    hits,
					     any**    userInfo,
					     list*    diags);

/*---------------------------------------------------------------------------*/
/* RETRIEVAL */
/*---------------------------------------------------------------------------*/

appConnStatus z39501988RetrieveReqWrite(appConn* conn,
					long     retrievalType,
					long     resSetPos,
					any*     recId,
					char*    docId,
					char*    elemId, 
					char*    varId,
					char*    dbName,
					long     startByte,
					long     lengthInBytes,
					any*     userInfo,
					list*    diags);

appConnStatus z39501988RetrieveRespRead(appConn* conn,
					char**   data,
					long*    dataLength,
					any**    userInfo,
					list*    diags);

/*-------------------------------------------------------------------------- */

#endif /* ndef connZ39501988_h */



