/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef conn1988Mgr_h
#define conn1988Mgr_h

#include "appConnMgr.h"
#include "wprot.h"

typedef struct appConn1988
{ appConn conn;
  long totalLength;
  long readSoFar;
  boolean transportDecodingDone;
  char encoding;
  boolean doingSearch; /* true if last operation was search, 
			  false if present */
  SearchAPDU* searchPDU;
} appConn1988;

appConnStatus z39501988Open(appConn** conn,
			    char* connType,
			    nConn* net,
			    char* buffer,
			    long bufSz,
			    long timeOutSecs,
			    long numArgs,...);

appConnStatus z39501988Free(appConn* conn);

appConnStatus z39501988PduInfo (appConn* conn,
				long*    pduType,
				long*    packetLength,
				list*    diags);

nConnStatus z39501988WriteMessage (nConn* net,
				   char*  buf,
				   long   size,
				   list*  diags);

#endif /* conn1988Mgr_h */
