/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef attr_h
#define attr_h

#define OID_ATTRSET_BIB1 "1.2.840.10003.3.1"

#define attrUndefined 9999

/* Bib-1 Use Attributes */
#define attrUseTitle     4L
#define attrUseAny    1016L
#define attrUseLocNum   12L
#define attrUseDocId  1032L

/* Bib-1 Relation Attributes */
#define attrRelatEql     3L
#define attrRelatRelv  102L

/* Bib-1 Structure Attributes */
#define attrStructWord       2L
#define attrStructURx      104L
#define attrStructFreeText 105L
#define attrStructDocText  106L
#define attrStructLocNum   107L

/* tAttrList defines the structure of the attribute lists. */   
#define attrTypeUse    1L
#define attrTypeRelat  2L
#define attrTypeStruct 4L

typedef struct {
  long sQryType;
  long sAttrUse;
  long sAttrRelat;
  long sAttrStruct;
} tAttrList;

/* tAttrTable is the table of the attributes lists supported. */
static tAttrList gAttrTable[] =
{
/* QryType,          attrUse,       attrRelat,     attrStruct */
  {qryLeafFreeText,  attrUseAny,    attrRelatRelv, attrStructFreeText},
  {qryLeafRecId,     attrUseLocNum, attrRelatEql,  attrStructLocNum  },
  {qryLeafDocId,     attrUseDocId,  attrRelatEql,  attrStructURx     },
  {qryLeafRFDocText, attrUseAny,    attrRelatRelv, attrStructDocText },
  {qryLeafRFRecId,   attrUseAny,    attrRelatRelv, attrStructLocNum  },
  {qryLeafRFDocId,   attrUseAny,    attrRelatRelv, attrStructURx     },
  {qryLeafUndefined, attrUndefined, attrUndefined, attrUndefined     }
};

#endif
