/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef connV2Cli_h
#define connV2Cli_h

#include "connV2Mgr.h"

appConnStatus z3950V2CliPduInfo(appConn* conn, 
				long*    pduType,
				long*    packetLength,
				list*    diags);

appConnStatus z3950V2InitReqWrite(appConn* conn,
				  char*    user,    
				  char*    password,
				  char*    clientInfo,
				  any*     userInfo,
				  list*    diags);

appConnStatus z3950V2InitRespRead(appConn* conn,
				  any**    userInfo,
				  list*    diags);

appConnStatus z3950V2SearchReqWrite(appConn*    conn,
				    long        maxHits,
				    long        hitsRequested, 
				    long        rankingScheme, 
				    char*       dbName, 
				    appConnQry* qry,
				    any*        userInfo,
				    list*       diags);

appConnStatus z3950V2SearchRespRead(appConn* conn,
				    long*    totalHits, 
				    list*    qryTermsUsed,
				    list*    hits,
				    any**    userInfo,
				    list*    diags);

appConnStatus z3950V2NextHeadlinesReqWrite(appConn* conn,
					   long     startingFromHit, 
					   long     hitsRequested,
					   any*     userInfo,
					   list*    diags);

appConnStatus z3950V2NextHeadlinesRespRead(appConn* conn,
					   list*    hits,
					   any**    userInfo,
					   list*    diags);

appConnStatus z3950V2RetrieveReqWrite(appConn* conn,
				      long     retrievalType,
				      long     resSetPos,
				      any*     recId,
				      char*    docId,
				      char*    elemId,
				      char*    varId,
				      char*    dbName,
				      long     startByte,
				      long     lengthInBytes,
				      any*     userInfo,
				      list*    diags);

appConnStatus z3950V2RetrieveRespRead(appConn* conn,
				      char**   data,
				      long*    dataLength,
				      any**    userInfo,
				      list*    diags);

#endif /* ndef connV2Cli_h */
