/*****************************************************************************
* 	        (c) Copyright 1994 Wide Area Information Servers, Inc        *
*	   	                 All rights reserved.   	             *
*									     *
*  This notice is intended as a precaution against inadvertent publication   *
*  and does not constitute an admission or acknowledgement that publication  *
*  has occurred or constitute a waiver of confidentiality.		     *
*									     *
*  Wide Area Information Server software is the proprietary and              *
*  confidential property of Wide Area Information Servers, Inc.              *
*****************************************************************************/

#ifndef connV2Mgr_h
#define connV2Mgr_h

#define MAX_STR_LEN 1000L
#define Z3950V2_IMP_ID        "1994"
#define Z3950V2_IMP_NAME      "WAIS Inc"
#define Z3950V2_IMP_VER       "Z39.50-V2 V1.0"
#define Z3950V2_PROT_VER      "110"
#define Z3950V2_OPTIONS       "110000000000000"
#define DEF_RES_SET_NAME      "default"

/* Element Sets */
#define FULL_ELEM_SET_NAME    "F"
#define BRIEF_ELEM_SET_NAME   "B"
#define VARIANT_ELEM_SET_NAME "VARIANT"
#define OBJ_ELEM_SET_NAME     "OBJ"

#define VARIANT_ELEM_SET  0
#define OBJ_ELEM_ELEM_SET 1

typedef struct appConnV2
{ appConn   conn;
  long      totalLength;	/* used by appConnInfo function. */
  long      readSoFar;		/* used by appConnInfo function. */
  boolean   doingRetrieval;	/* client state */
  char*     defResSetName;
  char*     defElmtSetName;
  char*     defPrefRecSyn;   
  long      retrievalTypeReq;
  long      resSetPosReq;
  any*      recIdReq;
  char*     docIdReq;
  char*     elemIdReq;
  char*     varIdReq;
  char*     targetPtr;
  char*     refId;             /* server state */
  char*     options;
  long      pduTag;
  long      startByteReq;
  long      smlSetUpBnd;
  long      lrgSetLoBnd;
  boolean   replInd;
  char*     resSetName;
  char*     dbName;
  char*     smlSetElmtSetName;
  char*     medSetElmtSetName;
  char*     elmtSetName;
  char*     prefRecSyn;
  long      startingFromHit;
} appConnV2;


nConnStatus z3950V2WriteMessage(nConn* net,
				char*  buf,
				long   size,
				list*  diags);

appConnStatus z3950V2Open (appConn** conn,
			   char*     connType,
			   nConn*    net,
			   char*     buffer,
			   long      bufSz,
			   long      timeOutSecs,
			   long      numArgs,...);

appConnStatus z3950V2Free (appConn* conn);

appConnStatus z3950V2PduInfo(appConn* conn, 
			     long*    packetLength,
			     list*    diags);

#endif /* ndef connV2Mgr_h */



